searchNodes=[{"doc":"FunServer is a GenServer in which instead of passing parameters to GenServer.call/3 or GenServer.cast/2 and then writing the corresponding callbacks with the necessary functionality you pass functions (i.e. handlers ). Essentially FunServer is just a simple wrapper over GenServer , which takes the approach of passing down functions instead of messages. Example Basically instead of using handle_call or handle_cast callbacks, functions are being passed that get executed in the corresponding callback. This is an example of a simple FunServer Stack Server. defmodule Server do use FunServer def start_link ( _args ) do FunServer . start_link ( __MODULE__ , handle_init ( [ ] ) , name : __MODULE__ ) end def push ( value ) do value |&gt; handle_push ( ) |&gt; FunServer . async ( __MODULE__ ) end def pop ( value ) do value |&gt; handle_pop ( ) |&gt; FunServer . sync ( __MODULE__ ) end defp handle_init ( args ) do fn -&gt; { :ok , args } end end defp handle_push ( value ) do fn state -&gt; { :noreply , [ value | state ] } end end defp handle_pop ( value ) do fn _from , [ value | new_state ] -&gt; { :noreply , value , new_state } end end end The callbacks FunServer wraps around are the following: init/1 handle_call/3 handle_cast/2 handle_continue/2 The rest of the callbacks for GenServer can be handled normally: handle_info/2 terminate/2 code_change/3 format_status/2","ref":"FunServer.html","title":"FunServer","type":"module"},{"doc":"Casts all servers locally registered as name at the specified nodes. For more information please refer to GenServer.abcast/3","ref":"FunServer.html#abcast/3","title":"FunServer.abcast/3","type":"function"},{"doc":"Executes an asynchronous call to the server . Works very similar to how a GenServer.cast/2 function works, but instead of passing message which is later handled in a handle_cast/2 callback, a function is passed, which gets evaluated on the server . For additional information please refer to GenServer.cast/2","ref":"FunServer.html#async/2","title":"FunServer.async/2","type":"function"},{"doc":"Calls all servers locally registered as name at the specified nodes. For more information please refer to GenServer.multi_call/4","ref":"FunServer.html#multi_call/4","title":"FunServer.multi_call/4","type":"function"},{"doc":"Replies to a client. For more information please refer to GenServer.reply/2","ref":"FunServer.html#reply/2","title":"FunServer.reply/2","type":"function"},{"doc":"Starts a FunServer process without links (outside of a supervision tree) For more information please refer to GenServer.start/3","ref":"FunServer.html#start/3","title":"FunServer.start/3","type":"function"},{"doc":"Starts a FunServer process linked to the current 'caller' process. For more information please refer to GenServer.start_link/3","ref":"FunServer.html#start_link/3","title":"FunServer.start_link/3","type":"function"},{"doc":"Synchronously stops the server with the given reason . For more information please refer to GenServer.stop/3","ref":"FunServer.html#stop/3","title":"FunServer.stop/3","type":"function"},{"doc":"Executes a synchronous call to the server and waits for a reply. Works very similar to how a GenServer.call/3 function works, but instead of passing message which is later handled in a handle_call/3 callback, a function is passed, which gets evaluated on the server . For additional information please refer to GenServer.call/3","ref":"FunServer.html#sync/3","title":"FunServer.sync/3","type":"function"},{"doc":"","ref":"FunServer.html#t:async_func_handler/0","title":"FunServer.async_func_handler/0","type":"type"},{"doc":"","ref":"FunServer.html#t:async_handler/0","title":"FunServer.async_handler/0","type":"type"},{"doc":"","ref":"FunServer.html#t:async_handler_response/0","title":"FunServer.async_handler_response/0","type":"type"},{"doc":"","ref":"FunServer.html#t:init_handler/0","title":"FunServer.init_handler/0","type":"type"},{"doc":"","ref":"FunServer.html#t:new_state/0","title":"FunServer.new_state/0","type":"type"},{"doc":"","ref":"FunServer.html#t:reason/0","title":"FunServer.reason/0","type":"type"},{"doc":"","ref":"FunServer.html#t:reply/0","title":"FunServer.reply/0","type":"type"},{"doc":"","ref":"FunServer.html#t:state/0","title":"FunServer.state/0","type":"type"},{"doc":"","ref":"FunServer.html#t:sync_func_handler/0","title":"FunServer.sync_func_handler/0","type":"type"},{"doc":"","ref":"FunServer.html#t:sync_handler/0","title":"FunServer.sync_handler/0","type":"type"},{"doc":"","ref":"FunServer.html#t:sync_handler_response/0","title":"FunServer.sync_handler_response/0","type":"type"},{"doc":"FunServer is a way of writing GenServer using functions instead of callbacks.","ref":"readme.html","title":"Overview","type":"extras"},{"doc":"Add :fun_server as a dependency to your project's mix.exs: defp deps do [ { :fun_server , &quot;~&gt; 0.1.0&quot; } ] end","ref":"readme.html#installation","title":"Overview - Installation","type":"extras"},{"doc":"defmodule Server do use FunServer def start_link ( _args ) do FunServer . start_link ( __MODULE__ , fn -&gt; { :ok , [ ] } end , name : __MODULE__ ) end def state ( ) do FunServer . sync ( fn _from , state -&gt; { :reply , state , state } end , __MODULE__ ) end def push ( value ) do value |&gt; handle_push ( ) |&gt; FunServer . async ( __MODULE__ ) end def pop ( value ) do value |&gt; handle_pop ( ) |&gt; FunServer . sync ( __MODULE__ ) end defp handle_push ( value ) do fn state -&gt; { :noreply , [ value | state ] } end end defp handle_pop ( value ) do fn _from , [ value | new_state ] -&gt; { :noreply , value , new_state } end end end","ref":"readme.html#usage","title":"Overview - Usage","type":"extras"},{"doc":"MIT License Copyright (c) 2023 Georgi Spasov Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"License","type":"extras"}]